/*
 * @(#)polyhex.h
 *
 * Copyright 1993 - 2008  David A. Bagley, bagleyd@tux.org
 *
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the author not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * This program is distributed in the hope that it will be "useful",
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/* polyhexes for Hextris */

#define MIN_UNITS	2 /* Why not 1 you say? */
#define MAX_UNITS	5
#define MIN_CORNERUNITS	MIN_UNITS
#define MAX_CORNERUNITS	4

#define NOCORN		0 /* Normal, ie no corners */
#define CORNERS		1 /* Normal and corners */
#define NOMIX		0 /* Do not mix lowered number squares with current */
#define MIXED		1
#define MAX_MODES	2
#define NONE		0 /* No rotation or reflection */
#define NOREFL		1 /* Normal, no reflection allow rotation */
#define ALL		2 /* Allow reflection or rotation */
#define MAX_TURNSTYLE_TYPES	3
#define DEFAULT_UNITS	4
#define DEFAULT_CORNERUNITS	4
#define MAX_POLYHEXES	186
#define MAX_START_POLYHEXES	58
#define HEX_SIZE	3
#define HEX_ROW_COL(i)	(2*i-1)
#define JUMPIN		0
#define GRADUAL		1

typedef struct {
	int         rotation;
	int         reflection;
	int         startHeight[2];
	int         shape[HEX_ROW_COL(MAX_UNITS)][HEX_ROW_COL(MAX_UNITS)];
	int         size;
} Polyhexes;
typedef struct {
	int         start[MAX_START_POLYHEXES][MAX_TURNSTYLE_TYPES];
	int         turnStyle;
} Mode;
typedef struct {
	Polyhexes polyhex[MAX_POLYHEXES];
	Mode        mode[MAX_MODES];
	int         number[MAX_MODES][MAX_TURNSTYLE_TYPES];
	char        cornersSwitch;
} Polytris;

extern Polytris tris[MAX_UNITS - MIN_UNITS + 1];
#ifdef WINVER
extern const char *polyhexColorString[MAX_START_POLYHEXES];
#else
extern const char *polyhexColorName[MAX_START_POLYHEXES];
#endif
extern int inHexagon(int size, int i, int j);
extern void readThings(void);
