/*
 * @(#)polyomino.c
 *
 * Copyright 1993 - 2008  David A. Bagley, bagleyd@tux.org
 *
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the author not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * This program is distributed in the hope that it will be "useful",
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#define MIN_UNITS	2 /* Why not 1 you say? */
#define MAX_UNITS	6
#define MIN_DIAGONALUNITS	MIN_UNITS
#define MAX_DIAGONALUNITS	3

#define NODIAG		0 /* Normal, ie no diagonals */
#define DIAGONAL	1 /* Normal and diagonal */
#define NOMIX		0 /* Do not mix lowered number squares with current */
#define MIXED		1
#define MAX_MODES	2
#define NONE		0 /* No rotation or reflection */
#define NOREFL		1 /* Normal, no reflection allow rotation */
#define ALL		2 /* Allow reflection or rotation */
#define MAX_TURNSTYLE_TYPES	3
#define DEFAULT_UNITS	4
#define DEFAULT_DIAGONALUNITS	3
#define MAX_POLYOMINOES	216
#define MAX_START_POLYOMINOES	55
#define JUMPIN		0
#define GRADUAL		1

typedef struct {
	int         rotation;
	int         reflection;
	int         startHeight[2];
	int         shape[MAX_UNITS][MAX_UNITS];
	int         size;
} Polyominoes;
typedef struct {
	int         number[MAX_MODES][MAX_TURNSTYLE_TYPES];
	int         start[MAX_START_POLYOMINOES][MAX_TURNSTYLE_TYPES];
	int         turnStyle;
} Mode;
typedef struct {
	Polyominoes polyomino[MAX_POLYOMINOES];
	Mode        mode[MAX_MODES];
	char        diagonalSwitch;
} Polytris;

extern Polytris tris[MAX_UNITS - MIN_UNITS + 1];
#ifdef WINVER
extern const char *polyominoColorString[MAX_START_POLYOMINOES];
#else
extern const char *polyominoColorName[MAX_START_POLYOMINOES];
#endif
extern void readThings(void);
